## tomoyo-tools 2.3.0

=== usr_lib_tomoyo/Makefile ===
BUILD_FILES = tomoyo-notifyd tomoyo-editpolicy-agent init_policy

all: $(BUILD_FILES)

install: all
	mkdir -p $(INSTALLDIR)/usr/lib/tomoyo
	chmod 755 $(INSTALLDIR)/usr/lib/tomoyo
	chown -R root:root .
	cp -af --remove-destination $(BUILD_FILES) tomoyotools.conf ../README.tomoyo ../COPYING.tomoyo $(INSTALLDIR)/usr/lib/tomoyo/

.c:
	$(CC) $(CFLAGS) -o $@ $<

clean:
	rm -f -- $(BUILD_FILES)

.PHONY: clean install

## tomoyo-tools 2.2.0-20100225

=== debian/changelog ===
tomoyo-tools (2.2.0-20100225-1) unstable; urgency=low

  [ Hideki Yamane (Debian-JP) ]
  * New upstream release (Closes: #536347, #571309)
  * debian/rules
    - convert to debhelper7 style
  * debian/control
    - add Ritesh Raj Sarraf <rrs@debian.org> to uploaders, thanks and welcome!
    - set "Build-Depends: debhelper (>= 7.0.50~)"
    - update my mail address
  * switch to dpkg-source format v3.0
  * debian/postrm
    - fix conffiles directory
  * debian/compat
    - set 7

  [ Ritesh Raj Sarraf ]
  * Update official Debian ID for maintenance
  * Remove the DM-Upload-Allowed: yes field since we both are DDs now 
  * Since upstream does not ship a changelog, use the debian changelog 
  * Add README.Debian and provide a brief explanation on how to enable tomoyo 

 -- Ritesh Raj Sarraf <rrs@debian.org>  Mon, 10 May 2010 21:23:03 +0530

tomoyo-tools (2.2.0-20090727-1) unstable; urgency=low

  * Initial release 

 -- Hideki Yamane (Debian-JP) <henrich@debian.or.jp>  Sat, 06 Feb 2010 12:12:36 +0900

=== debian/control ===
Source: tomoyo-tools
Section: admin
Priority: extra
Maintainer: Hideki Yamane <henrich@debian.org>
Uploaders: Ritesh Raj Sarraf <rrs@debian.org>
Homepage: http://tomoyo.sourceforge.jp/
Build-Depends: debhelper (>= 7.0.50~), libncurses5-dev, libreadline-dev
Standards-Version: 3.8.4
Vcs-Git: git://git.debian.org/collab-maint/tomoyo-tools.git
Vcs-Browser: http://git.debian.org/?p=collab-maint/tomoyo-tools.git

Package: tomoyo-tools
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: tomoyo-ccstools, tomoyo-ccstools1.7
Replaces: tomoyo-ccstools, tomoyo-ccstools1.7
Description: Lightweight and easy-use Mandatory Access Control for Linux
 TOMOYO Linux is Lightweight and Usable Mandatory Access Control with
  - "automatic policy configuring" feature by "LEARNING mode"
  - administrators friendly policy language
  - no need libselinux nor userland program modifications
 .
 TOMOYO Linux consists of patches to Linux kernel and administrative 
 utilities, and this package contains its audit daemon and tools.

=== debian/rules ===
#!/usr/bin/make -f
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@;

override_dh_auto_install:
	dh_auto_install -- INSTALLDIR=$(CURDIR)/debian/tomoyo-tools
	-rm $(CURDIR)/debian/tomoyo-tools/usr/lib/tomoyo/COPYING.tomoyo \
            $(CURDIR)/debian/tomoyo-tools/usr/lib/tomoyo/README.tomoyo
#	cd $(CURDIR)/debian/tomoyo-tools/usr/share/man/man8 && \
#	  ln -s ./tomoyo-editpolicy.8.gz tomoyo-editpolicy_offline.8.gz

override_dh_installchangelogs:
	dh_installchangelogs debian/changelog

=== debian/watch ===
version=3

opts="downloadurlmangle=s/sourceforge/iij.dl.sourceforge/;s/downloads\///;s/projects\///;s/gz\//gz/,\
uversionmangle=s/-beta/~beta/;s/-rc/~rc/;s/-preview/~preview/" \
 http://sourceforge.jp/projects/tomoyo/releases/ \
 /projects/tomoyo/downloads/.*/tomoyo-tools-(.*\..*)\.tar.gz/ debian uupdate

## tomoyo-tools 2.3.0-20100820

=== debian/changelog ===
tomoyo-tools (2.3.0-20100820-1ubuntu1) oneiric; urgency=low

  * Fix FTBFS with ld --as-needed. LP: #832904.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 12 Sep 2011 23:03:46 +0000

tomoyo-tools (2.3.0-20100820-1) unstable; urgency=low

  * New Upstream Release 
  * Add a get-orig-source target 
    - Update debian/watch file
    - Add target to debian/rules file
  * Add debian/preinst to handle upgrade from 2.2.x to 2.3.x 
  * Add help2man to build dependency 
  * Add new library package libtomoyotools1 
  * Bump Standards Version to 3.9.1 (No changes required) 
  * Add linux-image-2.6 into Recommends 
  * Add debian/NEWS 

 -- Ritesh Raj Sarraf <rrs@debian.org>  Sun, 13 Feb 2011 23:15:35 +0530

=== debian/rules ===
#!/usr/bin/make -f
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

PKG_VERS=$(shell dpkg-parsechangelog | grep ^Version: | cut -d '-' -f-2 | cut -d ' ' -f2)

get-orig-source:
	uscan --force-download --rename --repack --download-version=$(PKG_VERS) --destdir=.

%:
	dh $@;

override_dh_auto_install:
	dh_auto_install -- INSTALLDIR=$(CURDIR)/debian/tmp
	-rm $(CURDIR)/debian/tmp/usr/lib/tomoyo/COPYING.tomoyo \
            $(CURDIR)/debian/tmp/usr/lib/tomoyo/README.tomoyo

override_dh_installchangelogs:
	dh_installchangelogs debian/changelog

.PHONY: get-orig-source

=== debian/watch ===
version=3

opts="downloadurlmangle=s/sourceforge/iij.dl.sourceforge/;s/downloads\///;s/projects\///;s/gz\//gz/,\
uversionmangle=s/-beta/~beta/;s/-rc/~rc/;s/-preview/~preview/" \
 http://sourceforge.jp/projects/tomoyo/releases/ \
 /projects/tomoyo/downloads/.*/tomoyo-tools-(.*\..*)\.tar.gz/ debian

## tomoyo-tools 2.4.0-20111025

=== debian/changelog ===
tomoyo-tools (2.4.0-20111025-3) unstable; urgency=low

  * debian/postinst
    - tighten check for config directory (Closes: #652247)

 -- Hideki Yamane <henrich@debian.org>  Fri, 16 Dec 2011 23:04:08 +0900

tomoyo-tools (2.4.0-20111025-2) unstable; urgency=low

  * Upload to unstable 

 -- Hideki Yamane <henrich@debian.org>  Sun, 11 Dec 2011 21:47:41 +0900

tomoyo-tools (2.4.0-20111025-1) experimental; urgency=low

  * New upstream release (Closes: #651267)
  * debian/patches
    - drop ld--as-needed.patch as merged to upstream
  * debian/control,libtomoyotools2.{symbols,install}
    - change from libtomoyotools1 to 2
  * debian/{preinst,NEWS}
    - update it since this version does not have compatibility with previous
      version.

 -- Hideki Yamane <henrich@debian.org>  Tue, 06 Dec 2011 21:47:45 +0900

tomoyo-tools (2.3.0-20100820-4) unstable; urgency=low

  * debian/control
    - once remove Recommends: field, Thanks to Piotr Engelking 
      <inkerman42@gmail.com> (Closes: #629494)

 -- Hideki Yamane <henrich@debian.org>  Sun, 25 Sep 2011 19:27:39 +0900

tomoyo-tools (2.3.0-20100820-3) unstable; urgency=low

  * debian/postinst,postrm
    - make sure to remove meminfo.conf 

 -- Hideki Yamane <henrich@debian.org>  Sun, 25 Sep 2011 01:18:06 +0900

tomoyo-tools (2.3.0-20100820-2) unstable; urgency=low

  * debian/control
    - set Architecture: linux-any 
    - set Standards-Version: 3.9.2
    - drop "Ritesh Sarraf <rrs@debian.org>" from uploaders, thanks.
  * debian/patches
    - add ld--as-needed to fix ftbfs with ld --as-needed (Closes: #641403)
  * debian/rules
    - remove unnecessary override_dh_installchangelogs to fix lintian
      warning

 -- Hideki Yamane <henrich@debian.org>  Sat, 17 Sep 2011 17:52:17 +0900

=== debian/control ===
--- 
+++ 
@@ -2,15 +2,14 @@
 Section: admin
 Priority: extra
 Maintainer: Hideki Yamane <henrich@debian.org>
-Uploaders: Ritesh Raj Sarraf <rrs@debian.org>
 Homepage: http://tomoyo.sourceforge.jp/
-Build-Depends: debhelper (>= 7.0.50~), libncurses5-dev, libreadline-dev
-Standards-Version: 3.8.4
+Build-Depends: debhelper (>= 7.0.50~), libncurses5-dev, libreadline-dev, help2man
+Standards-Version: 3.9.2
 Vcs-Git: git://git.debian.org/collab-maint/tomoyo-tools.git
 Vcs-Browser: http://git.debian.org/?p=collab-maint/tomoyo-tools.git
 
 Package: tomoyo-tools
-Architecture: any
+Architecture: linux-any
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Conflicts: tomoyo-ccstools, tomoyo-ccstools1.7
 Replaces: tomoyo-ccstools, tomoyo-ccstools1.7
@@ -22,3 +21,20 @@
  .
  TOMOYO Linux consists of patches to Linux kernel and administrative 
  utilities, and this package contains its audit daemon and tools.
+
+Package: libtomoyotools2
+Section: libs
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Conflicts: libtomoyotools1
+Architecture: linux-any
+Suggests: tomoyo-tools
+Description: Lightweight and easy-use Mandatory Access Control for Linux (shared libraries)
+ TOMOYO Linux is Lightweight and Usable Mandatory Access Control with
+  - "automatic policy configuring" feature by "LEARNING mode"
+  - administrators friendly policy language
+  - no need libselinux nor userland program modifications
+ .
+ TOMOYO Linux consists of patches to Linux kernel and administrative 
+ utilities, and this package contains its audit daemon and tools.
+ .
+ Shared library used by the utilities in the tomoyo-tools package.

=== debian/rules ===
--- 
+++ 
@@ -15,7 +15,4 @@
 	-rm $(CURDIR)/debian/tmp/usr/lib/tomoyo/COPYING.tomoyo \
             $(CURDIR)/debian/tmp/usr/lib/tomoyo/README.tomoyo
 
-override_dh_installchangelogs:
-	dh_installchangelogs debian/changelog
-
 .PHONY: get-orig-source

## tomoyo-tools 2.5.0

=== kernel_test/Makefile ===
ALL_FILES = tomoyo_accept_test tomoyo_argv0_test tomoyo_bprm_test \
	tomoyo_cond_test tomoyo_env_test tomoyo_filesystem_test \
	tomoyo_file_test tomoyo_network_test tomoyo_new_file_test \
	tomoyo_new_network_test tomoyo_new_test tomoyo_policy_io_test \
	tomoyo_policy_memory_test tomoyo_rewrite_test tomoyo_transition_test \
	newns

all: $(ALL_FILES)
	chmod 755 testall.sh

$(ALL_FILES): include.h

CC=gcc

CFLAGS=-Wall -O2

#
# Tools for kernel testing.
#

.c:
	$(CC) $(CFLAGS) -o $@ $<

#
# Delete all test programs.
#

clean:
	rm -f $(ALL_FILES)

=== sbin/Makefile ===
include ../Include.make

BUILD_FILES = tomoyo-init

all: $(BUILD_FILES)

install: all
	mkdir -p -m 0755 $(INSTALLDIR)$(SBINDIR)
	$(INSTALL) -m 0700 $(BUILD_FILES) $(INSTALLDIR)$(SBINDIR)

.c:
	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -o $@ $<

clean:
	rm -f -- $(BUILD_FILES)

.PHONY: clean install

=== usr_lib_tomoyo/Makefile ===
include ../Include.make

BUILD_FILES = audit-exec-param tomoyo-editpolicy-agent convert-audit-log \
	convert-exec-param init_policy

all: $(BUILD_FILES)

install: all
	mkdir -p -m 0755 $(INSTALLDIR)/$(USRLIBDIR)/tomoyo
	$(INSTALL) -m 0755 $(BUILD_FILES) $(INSTALLDIR)/$(USRLIBDIR)/tomoyo/
	$(INSTALL) -m 0644 ../README.tomoyo ../COPYING.tomoyo $(INSTALLDIR)/$(USRLIBDIR)/tomoyo/

.c:
	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -o $@ $<

clean:
	rm -f -- $(BUILD_FILES)

.PHONY: clean install

=== usr_sbin/Makefile ===
include ../Include.make

BUILD_FILES := tomoyo-auditd tomoyo-checkpolicy tomoyo-diffpolicy tomoyo-domainmatch \
	tomoyo-editpolicy tomoyo-findtemp tomoyo-loadpolicy tomoyo-notifyd tomoyo-patternize \
	tomoyo-pstree tomoyo-queryd tomoyo-savepolicy tomoyo-selectpolicy tomoyo-setlevel \
	tomoyo-setprofile tomoyo-sortpolicy

all: libtomoyotools.so $(BUILD_FILES)

$(BUILD_FILES): libtomoyotools.so

/usr/include/curses.h:
	@echo "/usr/include/curses.h is missing."
	@echo "Run 'yum install ncurses-devel' or 'apt-get install libncurses-dev'"
	sleep 10

# -fPIE conflicts with -fPIC, disable it for libraries.
CFLAGS_PIC  := $(filter-out -fPIE,$(CFLAGS))
LDFLAGS_PIC := $(filter-out -pie,$(filter-out -fPIE,$(LDFLAGS)))

libtomoyotools.so: tomoyotools.c tomoyotools.h
	$(CC) $(CPPFLAGS) $(CFLAGS_PIC) $(LDFLAGS_PIC) -fPIC tomoyotools.c -shared -Wl,-soname,libtomoyotools.so.3 -o libtomoyotools.so.3.0.2
	ln -sf libtomoyotools.so.3.0.2 libtomoyotools.so

.c:
	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -o $@ $< -ltomoyotools -L. 

tomoyo-editpolicy: tomoyotools.h editpolicy*.c readline.h /usr/include/curses.h libtomoyotools.so
	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -o tomoyo-editpolicy editpolicy*.c -lncurses -ltomoyotools -L. -DCOLOR_ON

tomoyo-queryd: tomoyotools.h tomoyo-queryd.c readline.h /usr/include/curses.h libtomoyotools.so
	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -o tomoyo-queryd tomoyo-queryd.c -lncurses -ltomoyotools -L.

install: all
	mkdir -p -m 0755 $(INSTALLDIR)$(USRLIBDIR)
	$(INSTALL) -m 0755 libtomoyotools.so.3.0.2 $(INSTALLDIR)$(USRLIBDIR)
	ln -sf libtomoyotools.so.3.0.2 $(INSTALLDIR)$(USRLIBDIR)/libtomoyotools.so.3
ifeq ($(INSTALLDIR),)
	ldconfig || true
endif
	mkdir -p -m 0755 $(INSTALLDIR)$(USRSBINDIR)
	$(INSTALL) -m 0755 $(BUILD_FILES) $(INSTALLDIR)$(USRSBINDIR)

clean:
	rm -f -- $(BUILD_FILES) libtomoyotools.so*

.PHONY: clean install

## tomoyo-tools 2.5.0-20120414

=== debian/changelog ===
tomoyo-tools (2.5.0-20120414-1) unstable; urgency=low

  * New upstream release (Closes: #662938)
  * debian/control
    - set "Standards-Version: 3.9.3"
    - set "Build-Depends: debhelper (>= 9)" to use hardening flags
    - set "Recommends: tomoyo-tools" for libtomoyotools2
  * debian/compat
    - set 9
  * debian/rules
    - add "DEB_BUILD_MAINT_OPTIONS = hardening=+all"
     (however, Include.make specifies CFLAGS statically. So now it
      doesn't work)
  * debian/libtomoyotools2.symbols
    - update it
  * debian/README.Debian
    - describe how to enable tomoyo with grub2

 -- Hideki Yamane <henrich@debian.org>  Sat, 26 May 2012 06:25:51 +0900

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,8 @@
 Priority: extra
 Maintainer: Hideki Yamane <henrich@debian.org>
 Homepage: http://tomoyo.sourceforge.jp/
-Build-Depends: debhelper (>= 7.0.50~), libncurses5-dev, libreadline-dev, help2man
-Standards-Version: 3.9.2
+Build-Depends: debhelper (>= 9), libncurses5-dev, libreadline-dev, help2man
+Standards-Version: 3.9.3
 Vcs-Git: git://git.debian.org/collab-maint/tomoyo-tools.git
 Vcs-Browser: http://git.debian.org/?p=collab-maint/tomoyo-tools.git
 
@@ -27,7 +27,7 @@
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Conflicts: libtomoyotools1
 Architecture: linux-any
-Suggests: tomoyo-tools
+Recommends: tomoyo-tools
 Description: Lightweight and easy-use Mandatory Access Control for Linux (shared libraries)
  TOMOYO Linux is Lightweight and Usable Mandatory Access Control with
   - "automatic policy configuring" feature by "LEARNING mode"

=== debian/rules ===
#!/usr/bin/make -f
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@;

override_dh_auto_install:
	dh_auto_install -- INSTALLDIR=$(CURDIR)/debian/tmp
	-rm $(CURDIR)/debian/tmp/usr/lib/tomoyo/COPYING.tomoyo \
            $(CURDIR)/debian/tmp/usr/lib/tomoyo/README.tomoyo

PKG_VERS=$(shell dpkg-parsechangelog | grep ^Version: | cut -d '-' -f-2 | cut -d ' ' -f2)

get-orig-source:
	uscan --force-download --rename --repack --download-version=$(PKG_VERS) --destdir=.

.PHONY: get-orig-source

## tomoyo-tools 2.5.0-20130406

=== debian/changelog ===
tomoyo-tools (2.5.0-20130406-2) unstable; urgency=low

  * Upload to unstable 

 -- Hideki Yamane <henrich@debian.org>  Tue, 07 May 2013 13:15:45 +0900

tomoyo-tools (2.5.0-20130406-1) experimental; urgency=low

  * New upstream release
  * debian/watch
    - update it to deal with upstream page's change 

 -- Hideki Yamane <henrich@debian.org>  Sun, 07 Apr 2013 04:46:41 +0900

tomoyo-tools (2.5.0-20130214-2) experimental; urgency=low

  * debian/tomoyo-tools.postinst
    - fix to exec init_policy
    - care other grub parameter 
    - print message if grub environment doesn't exist
  * debian/control
    - set Standards-Version: 3.9.4

 -- Hideki Yamane <henrich@debian.org>  Sun, 03 Mar 2013 12:47:13 +0900

tomoyo-tools (2.5.0-20130214-1) experimental; urgency=low

  * New upstream release
  * debian/po
    - add Japanese (victory <victory.deb@gmail.com>): Closes: #692204
  * debian/patches
    - drop use-dpkg-buildflags.patch: merged to upstream

 -- Hideki Yamane <henrich@debian.org>  Wed, 27 Feb 2013 11:54:09 +0900

tomoyo-tools (2.5.0-20120805-1) experimental; urgency=low

  * New upstream release
  * debian/libtomoyo3.symbols
    - update to 2.5.0-20120805

 -- Hideki Yamane <henrich@debian.org>  Thu, 09 Aug 2012 22:16:18 +0900

tomoyo-tools (2.5.0-20120414-4) unstable; urgency=low

  [ Christian Perrier ]
  * Debconf templates and debian/control reviewed by the debian-l10n-
    english team as part of the Smith review project. Closes: #680088

  [Debconf translation updates]
  * Slovak (Ivan Masár).  Closes: #681956
  * Russian (Yuri Kozlov).  Closes: #682131
  * Polish (Michał Kułach).  Closes: #682324
  * Portuguese (Pedro Ribeiro).  Closes: #682377
  * Danish (Joe Hansen).  Closes: #682387
  * German (Chris Leick).  Closes: #682484
  * French (Julien Patriarca).  Closes: #682498
  * Spanish; (# traductor (campo Last-Translator) y ponga en copia a la
    lista de Javier Fernández-Sanguino).  Closes: #682559
  * Swedish (Martin Bagge / brother).  Closes: #682565
  * Czech (Miroslav Kure).  Closes: #682690
  * Italian (Beatrice Torracca).  Closes: #682988

  [ Hideki Yamane ]
  * upload to unstable.

 -- Hideki Yamane <henrich@debian.org>  Mon, 06 Aug 2012 10:58:37 +0900

tomoyo-tools (2.5.0-20120414-3) unstable; urgency=low

  * debian/rules
    - add override_dh_install to exclude files
    - exec debconf-updatepo in override_dh_clean
  * debian/tomoyo-tools.{pre,post}{inst,rm}
    - add stat.conf to CONFFILE
    - rename to tomoyo-tools.* 
  * With this release, you can enable tomoyo automatically with debconf.
    It set /etc/default/grub and exec update-grub.
    - debian/tomoyo-tools.post{inst,rm}
      + add some line for debconf
    - debian/tomoyo-tools.{templates,config}
      + add it to enable debconf
    - debian/control
      + add "Build-Depends: po-debconf" and "Pre-Depends: debconf"
    - debian/README.Debian
      + update it 
  * debian/{tomoyo-tools,libtomoyotools3}.lintian-overrides
    - add it to override "no-upstream-changelog" warning, upstream changelog
      is provided as README.tomoyo file

 -- Hideki Yamane <henrich@debian.org>  Fri, 15 Jun 2012 09:08:23 +0900

tomoyo-tools (2.5.0-20120414-2) unstable; urgency=low

  * debian/control
    - remove "Build-Depends: help2man" because it's not necessary.
    - change libtomoyotools2 to 3, and add "Conflicts:" to old lib.
  * debian/libtomoyotools2.{install,symbols}
    - change libtomoyotools2 to 3
  * debian/patches
    - add use-dpkg-buildflags.patch provided by Simon Ruderich
      <simon@ruderich.org>, Thanks! (Closes: #674723)

 -- Hideki Yamane <henrich@debian.org>  Mon, 28 May 2012 08:06:07 +0900

=== debian/control ===
Source: tomoyo-tools
Section: admin
Priority: extra
Maintainer: Hideki Yamane <henrich@debian.org>
Homepage: http://tomoyo.sourceforge.jp/
Build-Depends: debhelper (>= 9), libncurses5-dev, libreadline-dev, po-debconf
Standards-Version: 3.9.4
Vcs-Git: git://git.debian.org/collab-maint/tomoyo-tools.git
Vcs-Browser: http://git.debian.org/?p=collab-maint/tomoyo-tools.git

Package: tomoyo-tools
Architecture: linux-any
Pre-Depends: debconf
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: tomoyo-ccstools, tomoyo-ccstools1.7
Replaces: tomoyo-ccstools, tomoyo-ccstools1.7
Description: lightweight Linux Mandatory Access Control system
 TOMOYO Linux is a lightweight and easy-to-use path-based Mandatory
 Access Control (MAC) implementation with:
  * automatic policy configuration via "learning" mode;
  * an administrator-friendly policy language;
  * no need for SELinux, or userland program modifications.
 .
 This package provides the audit daemon and administrative utilities for
 use on a Linux kernel with TOMOYO support (standard in Debian kernels).

Package: libtomoyotools3
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: libtomoyotools1, libtomoyotools2
Architecture: linux-any
Recommends: tomoyo-tools
Description: lightweight Linux Mandatory Access Control system - library
 TOMOYO Linux is a lightweight and easy-to-use path-based Mandatory
 Access Control (MAC) implementation with:
  * automatic policy configuration via "learning" mode;
  * an administrator-friendly policy language;
  * no need for SELinux, or userland program modifications.
 .
 This package provides the shared library used by the utilities in the
 tomoyo-tools package.

=== debian/rules ===
#!/usr/bin/make -f
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_install:
	dh_auto_install -- INSTALLDIR=$(CURDIR)/debian/tmp

override_dh_install:
	dh_install -XCOPYING.tomoyo -XREADME.tomoyo

override_dh_clean:
	dh_clean
	debconf-updatepo

PKG_VERS=$(shell dpkg-parsechangelog | grep ^Version: | cut -d'-' -f-2 | cut -d' ' -f2)

get-orig-source:
	uscan --force-download --rename --repack --download-version=$(PKG_VERS) --destdir=.

.PHONY: get-orig-source

=== debian/watch ===
version=3

opts="downloadurlmangle=s/sourceforge/jaist.dl.sourceforge/;s/downloads\///;s/projects\///;s/gz\//gz/,\
uversionmangle=s/-beta/~beta/;s/-rc/~rc/;s/-preview/~preview/" \
 http://sourceforge.jp/projects/tomoyo/releases/?package_id=9818 \
 /projects/tomoyo/downloads/.*/tomoyo-tools-(.*\..*)\.tar.gz/ debian

## tomoyo-tools 2.5.0-20131225

=== debian/changelog ===
tomoyo-tools (2.5.0-20131225-1) unstable; urgency=medium

  * New upstream release
  * debian/control
    - set Standards-Version: 3.9.5 with no changes
    - use canonical URL
  * update debian/libtomoyotools3.symbols
  * debian/watch
    - add debian/upstream-signing-key.pgp and update it to check upstream's
      cryptographic signature verification
  * add debian/upstream-signing-key.pgp for above change

 -- Hideki Yamane <henrich@debian.org>  Mon, 30 Dec 2013 23:37:06 +0900

## tomoyo-tools 2.5.0-20140105

=== debian/changelog ===
tomoyo-tools (2.5.0-20140105-2) unstable; urgency=medium

  * move upstream pgp key to debian/upstream/signing-key.pgp 
  * debian/tomoyo-post{inst,rm}
    - fix "double entry of tomoyo for grub menu" (Closes: #717326)
      Thanks to Osamu Aoki <osamu@debian.org> for the patch
  * debian/source/lintian-overrides
    - add it to avoid lintian false-positive error

 -- Hideki Yamane <henrich@debian.org>  Sat, 15 Mar 2014 06:38:32 +0900

tomoyo-tools (2.5.0-20140105-1) unstable; urgency=medium

  * Imported Upstream version 2.5.0-20140105
  * update debian/libtomoyotools3.symbols

 -- Hideki Yamane <henrich@debian.org>  Sun, 12 Jan 2014 15:31:06 +0900

=== debian/control ===
--- 
+++ 
@@ -4,9 +4,9 @@
 Maintainer: Hideki Yamane <henrich@debian.org>
 Homepage: http://tomoyo.sourceforge.jp/
 Build-Depends: debhelper (>= 9), libncurses5-dev, libreadline-dev, po-debconf
-Standards-Version: 3.9.4
-Vcs-Git: git://git.debian.org/collab-maint/tomoyo-tools.git
-Vcs-Browser: http://git.debian.org/?p=collab-maint/tomoyo-tools.git
+Standards-Version: 3.9.5
+Vcs-Git: git://anonscm.debian.org/collab-maint/tomoyo-tools.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/tomoyo-tools.git
 
 Package: tomoyo-tools
 Architecture: linux-any

=== debian/watch ===
version=3

opts="downloadurlmangle=s/sourceforge/jaist.dl.sourceforge/;s/downloads\///;s/projects\///;s/gz\//gz/,\
uversionmangle=s/-beta/~beta/;s/-rc/~rc/;s/-preview/~preview/,\
pgpsigurlmangle=s/$/.asc/" \
 http://sourceforge.jp/projects/tomoyo/releases/?package_id=9818 \
 /projects/tomoyo/downloads/.*/tomoyo-tools-(.*\..*)\.tar.gz/ debian

## tomoyo-tools 2.5.0-20140601

=== debian/changelog ===
tomoyo-tools (2.5.0-20140601-6) unstable; urgency=medium

  * fix debian/tomoyo-tools.post{inst,rm} to work  
    Thanks to upstream to point it out.

 -- Hideki Yamane <henrich@debian.org>  Sun, 03 Jan 2016 12:08:23 +0900

tomoyo-tools (2.5.0-20140601-5) unstable; urgency=medium

  * update debian/watch 
  * debian/copyright
    - convert to copyright format 1.0

 -- Hideki Yamane <henrich@debian.org>  Sun, 13 Dec 2015 16:11:53 +0900

tomoyo-tools (2.5.0-20140601-4) unstable; urgency=medium

  * debian/control
    - update Vcs-* 
    - update Homepage
  * debian/tomoyo-tools.post{inst,rm}
    - fix "command-with-path-in-maintainer-script"

 -- Hideki Yamane <henrich@debian.org>  Mon, 07 Dec 2015 21:19:59 +0900

tomoyo-tools (2.5.0-20140601-3) unstable; urgency=medium

  * debian/control
    - set Standards-Version: 3.9.6
    - update Vcs-Browser

 -- Hideki Yamane <henrich@debian.org>  Fri, 02 Jan 2015 23:59:42 +0900

tomoyo-tools (2.5.0-20140601-2) unstable; urgency=medium

  * debian/po
    - add nl.po: thanks to Frans Spiesschaert <Frans.Spiesschaert@yucom.be> 
      (Closes: #766536)

 -- Hideki Yamane <henrich@debian.org>  Sat, 01 Nov 2014 13:48:09 +0900

tomoyo-tools (2.5.0-20140601-1) unstable; urgency=medium

  * Imported Upstream version 2.5.0-20140601 

 -- Hideki Yamane <henrich@debian.org>  Mon, 09 Jun 2014 06:56:08 +0900

=== debian/control ===
--- 
+++ 
@@ -2,11 +2,11 @@
 Section: admin
 Priority: extra
 Maintainer: Hideki Yamane <henrich@debian.org>
-Homepage: http://tomoyo.sourceforge.jp/
+Homepage: https://tomoyo.osdn.jp/
 Build-Depends: debhelper (>= 9), libncurses5-dev, libreadline-dev, po-debconf
-Standards-Version: 3.9.5
-Vcs-Git: git://anonscm.debian.org/collab-maint/tomoyo-tools.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/tomoyo-tools.git
+Standards-Version: 3.9.6
+Vcs-Git: https://anonscm.debian.org/git/collab-maint/tomoyo-tools.git
+Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/tomoyo-tools.git
 
 Package: tomoyo-tools
 Architecture: linux-any

=== debian/watch ===
version=3

opts="downloadurlmangle=s/osdn/jaist.dl.osdn/;s/downloads\///;s/projects\///;s/gz\//gz/,\
uversionmangle=s/-beta/~beta/;s/-rc/~rc/;s/-preview/~preview/,\
pgpsigurlmangle=s/$/.asc/" \
 http://osdn.jp/projects/tomoyo/releases/?package_id=9818 \
 /projects/tomoyo/downloads/.*/tomoyo-tools-(.*\..*)\.tar.gz/ debian

## tomoyo-tools 2.5.0-20170102

=== debian/changelog ===
tomoyo-tools (2.5.0-20170102-3) unstable; urgency=medium

  * debian/copyright
    - update copyright year and use https 
  * debian/control
    - move Vcs-* to salsa.debian.org
    - set debhelper (>= 11)
    - set Standards-Version: 4.1.3
  * debian/compat
    - set 11

 -- Hideki Yamane <henrich@debian.org>  Wed, 14 Feb 2018 21:02:48 +0900

tomoyo-tools (2.5.0-20170102-2) unstable; urgency=medium

  * debian/control
    - set Standards-Version: 4.1.1
    - set Priority: optional
  * debian/watch
    - update to version 4
  * debian/copyright
    - update upstream Source URL to osdn.net
    - update copyright year
  * debian/rules
    - simplify rules
  * debian/upstream/signing-key.{pgp,asc}
    - convert .pgp to .asc
  * debian/{libtomoyotools3,/tomoyo-tools}.lintian-overrides
    - drop it, too much aggressive

 -- Hideki Yamane <henrich@debian.org>  Sun, 22 Oct 2017 04:36:04 +0900

tomoyo-tools (2.5.0-20170102-1) unstable; urgency=medium

  * New upstream release
  * debian/compat
    - set 10
  * debian/control
    - bump up to debhalper (>= 10)
  * remove unnecessary debian/source/lintian-overrides

 -- Hideki Yamane <henrich@debian.org>  Wed, 04 Jan 2017 19:14:53 +0900

tomoyo-tools (2.5.0-20140601-7) unstable; urgency=medium

  * add debian/po/pt_BR.po (Closes: #835359) 
  * debian/control
    - set Standards-Version: 3.9.8

 -- Hideki Yamane <henrich@debian.org>  Sat, 17 Sep 2016 10:21:32 +0900

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,12 @@
 Source: tomoyo-tools
 Section: admin
-Priority: extra
+Priority: optional
 Maintainer: Hideki Yamane <henrich@debian.org>
 Homepage: https://tomoyo.osdn.jp/
-Build-Depends: debhelper (>= 9), libncurses5-dev, libreadline-dev, po-debconf
-Standards-Version: 3.9.6
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/tomoyo-tools.git
-Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/tomoyo-tools.git
+Build-Depends: debhelper (>= 11), libncurses5-dev, libreadline-dev, po-debconf
+Standards-Version: 4.1.3
+Vcs-Git: https://salsa.debian.org/debian/tomoyo-tools.git
+Vcs-Browser: https://salsa.debian.org/debian/tomoyo-tools
 
 Package: tomoyo-tools
 Architecture: linux-any

=== debian/watch ===
version=4

opts="downloadurlmangle=s/osdn/jaist.dl.osdn/;s/downloads\///;s/projects\///;s/gz\//gz/,\
uversionmangle=s/-beta/~beta/;s/-rc/~rc/;s/-preview/~preview/,\
pgpsigurlmangle=s/$/.asc/" \
 https://osdn.net/projects/tomoyo/releases/?package_id=9818 \
 /projects/tomoyo/downloads/.*/@PACKAGE@@ANY_VERSION@@ARCHIVE_EXT@/ debian

## tomoyo-tools 2.6.0

=== Makefile ===
all:
	$(MAKE) -C sbin all
	$(MAKE) -C usr_sbin all
	$(MAKE) -C usr_lib_tomoyo all

install: all
	$(MAKE) -C sbin install
	$(MAKE) -C usr_sbin install
	$(MAKE) -C usr_lib_tomoyo install
	$(MAKE) -C usr_share_man install

clean:
##
## I don't enable "find" line because older versions does not support -delete
## action.
##
#	find -name '*~' -delete
	$(MAKE) -C sbin clean
	$(MAKE) -C usr_sbin clean
	$(MAKE) -C usr_lib_tomoyo clean

.PHONY: clean install

=== kernel_test/Makefile ===
--- 
+++ 
@@ -1,3 +1,5 @@
+include ../Include.make
+
 ALL_FILES = tomoyo_accept_test tomoyo_argv0_test tomoyo_bprm_test \
 	tomoyo_cond_test tomoyo_env_test tomoyo_filesystem_test \
 	tomoyo_file_test tomoyo_network_test tomoyo_new_file_test \
@@ -10,16 +12,16 @@
 
 $(ALL_FILES): include.h
 
-CC=gcc
 
-CFLAGS=-Wall -O2
 
 #
 # Tools for kernel testing.
 #
 
+BINDIR = '"'$(shell readlink -f /bin)'"'
+
 .c:
-	$(CC) $(CFLAGS) -o $@ $<
+	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -DBINDIR=$(BINDIR) -o $@ $<
 
 #
 # Delete all test programs.

=== usr_sbin/Makefile ===
--- 
+++ 
@@ -19,22 +19,24 @@
 LDFLAGS_PIC := $(filter-out -pie,$(filter-out -fPIE,$(LDFLAGS)))
 
 libtomoyotools.so: tomoyotools.c tomoyotools.h
-	$(CC) $(CPPFLAGS) $(CFLAGS_PIC) $(LDFLAGS_PIC) -fPIC tomoyotools.c -shared -Wl,-soname,libtomoyotools.so.3 -o libtomoyotools.so.3.0.2
-	ln -sf libtomoyotools.so.3.0.2 libtomoyotools.so
+	$(CC) $(CPPFLAGS) $(CFLAGS_PIC) $(LDFLAGS_PIC) -fPIC tomoyotools.c -shared -Wl,-soname,libtomoyotools.so.3 -o libtomoyotools.so.3.0.4
+	ln -sf libtomoyotools.so.3.0.4 libtomoyotools.so
 
 .c:
-	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -o $@ $< -ltomoyotools -L. 
+	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -o $@ $< -ltomoyotools -L.
 
 tomoyo-editpolicy: tomoyotools.h editpolicy*.c readline.h /usr/include/curses.h libtomoyotools.so
+	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -o tomoyo-editpolicy editpolicy*.c -lncurses -ltinfo -ltomoyotools -L. -DCOLOR_ON || \
 	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -o tomoyo-editpolicy editpolicy*.c -lncurses -ltomoyotools -L. -DCOLOR_ON
 
 tomoyo-queryd: tomoyotools.h tomoyo-queryd.c readline.h /usr/include/curses.h libtomoyotools.so
+	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -o tomoyo-queryd tomoyo-queryd.c -lncurses -ltinfo -ltomoyotools -L. || \
 	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -o tomoyo-queryd tomoyo-queryd.c -lncurses -ltomoyotools -L.
 
 install: all
 	mkdir -p -m 0755 $(INSTALLDIR)$(USRLIBDIR)
-	$(INSTALL) -m 0755 libtomoyotools.so.3.0.2 $(INSTALLDIR)$(USRLIBDIR)
-	ln -sf libtomoyotools.so.3.0.2 $(INSTALLDIR)$(USRLIBDIR)/libtomoyotools.so.3
+	$(INSTALL) -m 0755 libtomoyotools.so.3.0.4 $(INSTALLDIR)$(USRLIBDIR)
+	ln -sf libtomoyotools.so.3.0.4 $(INSTALLDIR)$(USRLIBDIR)/libtomoyotools.so.3
 ifeq ($(INSTALLDIR),)
 	ldconfig || true
 endif

=== usr_share_man/Makefile ===
include ../Include.make

install:
	mkdir -p -m 0755 $(INSTALLDIR)$(MAN8)
	$(INSTALL) -m 0644 man8/* $(INSTALLDIR)$(MAN8)

.PHONY: install

## tomoyo-tools 2.6.0-20190305

=== debian/changelog ===
tomoyo-tools (2.6.0-20190305-1) unstable; urgency=medium

  * New upstream release 
  * debian/control
    - set Standards-Version: 4.3.0
    - use dh12
    - add Rules-Requires-Root: no
  * debian/copyright
    - update copyright year
  * drop unnecessary debian/upstream/signing-key.pgp, we have .asc file

  [ Ondřej Nový ]
  * d/changelog: Remove trailing whitespaces

 -- Hideki Yamane <henrich@debian.org>  Sat, 09 Mar 2019 19:48:43 +0900

tomoyo-tools (2.5.0-20170102-4) unstable; urgency=medium

  * debian/watch
    - Update to deal with upstream's change
  * debian/control
    - Set Standards-Version: 4.1.4
  * add simple CI setting

 -- Hideki Yamane <henrich@debian.org>  Thu, 31 May 2018 22:52:33 +0900

=== debian/control ===
--- 
+++ 
@@ -3,10 +3,12 @@
 Priority: optional
 Maintainer: Hideki Yamane <henrich@debian.org>
 Homepage: https://tomoyo.osdn.jp/
-Build-Depends: debhelper (>= 11), libncurses5-dev, libreadline-dev, po-debconf
-Standards-Version: 4.1.3
+Build-Depends: debhelper (>= 12), debhelper-compat (= 12),
+               libncurses5-dev, libreadline-dev, po-debconf
+Standards-Version: 4.3.0
 Vcs-Git: https://salsa.debian.org/debian/tomoyo-tools.git
 Vcs-Browser: https://salsa.debian.org/debian/tomoyo-tools
+Rules-Requires-Root: no
 
 Package: tomoyo-tools
 Architecture: linux-any

=== debian/rules ===
--- 
+++ 
@@ -16,10 +16,3 @@
 override_dh_clean:
 	dh_clean
 	debconf-updatepo
-
-PKG_VERS=$(shell dpkg-parsechangelog | grep ^Version: | cut -d'-' -f-2 | cut -d' ' -f2)
-
-get-orig-source:
-	uscan --force-download --rename --repack --download-version=$(PKG_VERS) --destdir=.
-
-.PHONY: get-orig-source

## tomoyo-tools 2.6.0-20201111

=== debian/changelog ===
tomoyo-tools (2.6.0-20201111-1) unstable; urgency=medium

  * New upstream release 
  * debian/control
    - Set debhelper-compat (= 12)
      - Once set = 13 but back to avoid dh_missing failure
    - Set Standards-Version: 4.5.1
    - Drop unnecessary "Build-Depends: debconf-po"
  * Add debian/not-installed file and rename docs to tomoyo-tools.docs
    to avoid dh_missing failure
  * Split to tomoyo-tools.manpages
  * debian/patches
    - add remove_unnecessary_doc.patch
  * Simplify debian/rules
  * Update debian/libtomoyotools3.symbols
  * Drop debian/.gitlab-ci.yml and use debian/salsa-ci.yml instead
  * Drop unnecessary entry as debian/source/include-binaries
  * debian/NEWS,tomoyo-tools.{postinst,preinst}
    - Note incompatibility with older kernel and remove "security=tomoyo"
      from grub setting (Closes: #932803, #976261)
      Thanks to Topi Miettinen <toiwoton@gmail.com> and Alois Wohlschlager
      <alois1@gmx-topmail.de>
  * debian/tomoyo-tools/postinst
    - Fix to create policy files
  * debian/{po,tomoyo-tools.templates,tomoyo-tools.config}
    - Drop debconf messages related files

 -- Hideki Yamane <henrich@debian.org>  Sun, 24 Jan 2021 23:54:19 +0900

=== debian/control ===
--- 
+++ 
@@ -3,9 +3,9 @@
 Priority: optional
 Maintainer: Hideki Yamane <henrich@debian.org>
 Homepage: https://tomoyo.osdn.jp/
-Build-Depends: debhelper (>= 12), debhelper-compat (= 12),
-               libncurses5-dev, libreadline-dev, po-debconf
-Standards-Version: 4.3.0
+Build-Depends: debhelper-compat (= 12),
+               libncurses5-dev, libreadline-dev
+Standards-Version: 4.5.1
 Vcs-Git: https://salsa.debian.org/debian/tomoyo-tools.git
 Vcs-Browser: https://salsa.debian.org/debian/tomoyo-tools
 Rules-Requires-Root: no

## tomoyo-tools 2.6.1

=== usr_sbin/Makefile ===
--- 
+++ 
@@ -9,8 +9,8 @@
 
 $(BUILD_FILES): libtomoyotools.so
 
-/usr/include/curses.h:
-	@echo "/usr/include/curses.h is missing."
+/usr/include/ncurses.h:
+	@echo "/usr/include/ncurses.h is missing."
 	@echo "Run 'yum install ncurses-devel' or 'apt-get install libncurses-dev'"
 	sleep 10
 
@@ -25,13 +25,13 @@
 .c:
 	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -o $@ $< -ltomoyotools -L.
 
-tomoyo-editpolicy: tomoyotools.h editpolicy*.c readline.h /usr/include/curses.h libtomoyotools.so
-	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -o tomoyo-editpolicy editpolicy*.c -lncurses -ltinfo -ltomoyotools -L. -DCOLOR_ON || \
-	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -o tomoyo-editpolicy editpolicy*.c -lncurses -ltomoyotools -L. -DCOLOR_ON
+tomoyo-editpolicy: tomoyotools.h editpolicy*.c readline.h /usr/include/ncurses.h libtomoyotools.so
+	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -o tomoyo-editpolicy editpolicy*.c -lncurses -ltinfo -ltomoyotools -L. -DCOLOR_ON -DNCURSES_WIDECHAR=0 || \
+	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -o tomoyo-editpolicy editpolicy*.c -lncurses -ltomoyotools -L. -DCOLOR_ON -DNCURSES_WIDECHAR=0
 
-tomoyo-queryd: tomoyotools.h tomoyo-queryd.c readline.h /usr/include/curses.h libtomoyotools.so
-	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -o tomoyo-queryd tomoyo-queryd.c -lncurses -ltinfo -ltomoyotools -L. || \
-	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -o tomoyo-queryd tomoyo-queryd.c -lncurses -ltomoyotools -L.
+tomoyo-queryd: tomoyotools.h tomoyo-queryd.c readline.h /usr/include/ncurses.h libtomoyotools.so
+	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -o tomoyo-queryd tomoyo-queryd.c -lncurses -ltinfo -ltomoyotools -L. -DNCURSES_WIDECHAR=0 || \
+	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -o tomoyo-queryd tomoyo-queryd.c -lncurses -ltomoyotools -L. -DNCURSES_WIDECHAR=0
 
 install: all
 	mkdir -p -m 0755 $(INSTALLDIR)$(USRLIBDIR)

## tomoyo-tools 2.6.1-20210910

=== debian/changelog ===
tomoyo-tools (2.6.1-20210910-1) unstable; urgency=medium

  * New upstream release
  * debian/control
    - Set Standards-Version: 4.6.0
    - Drop unnecessary old Conflicts and Replaces

 -- Hideki Yamane <henrich@debian.org>  Sun, 24 Oct 2021 23:31:53 +0900

=== debian/rules ===
#!/usr/bin/make -f
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_install:
	dh_auto_install -- INSTALLDIR=$(CURDIR)/debian/tmp

=== debian/watch ===
version=4

opts="downloadurlmangle=s%projects/tomoyo/downloads%frs/redir\.php?m=iij&f=tomoyo%g;s/gz\//gz/;s/asc\//asc/, \
pagemangle=s%<osdn:file url="([^<]*)</osdn:file>%<a href="$1">$1</a>%g, \
uversionmangle=s/-beta/~beta/;s/-rc/~rc/;s/-preview/~preview/,\
pgpsigurlmangle=s/$/.asc/" \
https://osdn.net/projects/tomoyo/releases/rss \
 https://osdn.net/projects/tomoyo/downloads/.*/@PACKAGE@@ANY_VERSION@@ARCHIVE_EXT@/ debian uupdate
